/*
 * irc2.7.2/ircd/res.h (C)opyright 1992 Darren Reed.
 */

#ifndef __RES_H__
#define __RES_H__

#include "setup.h"
#if HAVE_TIME_H
#include <time.h>
#endif
#if HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#include <netinet/in.h>
#include <netdb.h>
#ifdef HPUX
#ifndef h_errno
extern int h_errno;
#endif
#endif

#define MYRES_TYPE_CLIENT		1
#define MYRES_TYPE_SERVLINK		2

typedef struct _myres_hostent	MYRES_HOSTENT;
typedef struct _myres_status	MYRES_STATUS;

struct _myres_hostent
{
    struct hostent  h;
    char            *buf;
};

struct _myres_status
{
#define MYRES_TYPE_PTR	1
#define MYRES_TYPE_A	2
	int				type;		/* A or PTR */
	int				ctype;		/* CLIENT, SERVLINK, etc */
	int				result;		/* 1 for OK, 0 for not */
	MYRES_HOSTENT	he;			/* if result==1 */
	void			*rptr;		/* if still doing DNS */
	void			*cptr;
};


/*=============================================================================
 * Proto types
 */

int myres_init(void);
MYRES_HOSTENT *myres_gethostbyname(char *name, MYRES_STATUS *cptr);
MYRES_HOSTENT *myres_gethostbyaddr(struct in_addr *addr, MYRES_STATUS *cptr);
void myres_add_local_domain(char *hname, int size);
void myres_status_init(MYRES_STATUS *cptr, void *ptr, int type);
void myres_status_deinit(MYRES_STATUS *cptr);
MYRES_STATUS *myres_get_answer(void);
int myres_hostent_move(MYRES_HOSTENT *new_hp, MYRES_HOSTENT *old_hp);
int myres_hostent_dup(MYRES_HOSTENT *new_hp, MYRES_HOSTENT *old_hp);
int myres_hostent_free(MYRES_HOSTENT *heptr);
int myres_retry_request(void *reqptr);

#endif /* __RES_H__ */
